"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.copy = copy;

var _dom = require("@testing-library/dom");

var _setup = require("../setup");

var _utils = require("../utils");

async function copy() {
  var _doc$activeElement;

  const doc = this[_setup.Config].document;
  const target = (_doc$activeElement = doc.activeElement) != null ? _doc$activeElement :
  /* istanbul ignore next */
  doc.body;
  const clipboardData = (0, _utils.copySelection)(target);

  if (clipboardData.items.length === 0) {
    return;
  }

  _dom.fireEvent.copy(target, {
    clipboardData
  });

  if (this[_setup.Config].writeToClipboard) {
    await (0, _utils.writeDataTransferToClipboard)(doc, clipboardData);
  }

  return clipboardData;
}