"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cut = cut;

var _dom = require("@testing-library/dom");

var _setup = require("../setup");

var _utils = require("../utils");

async function cut() {
  var _doc$activeElement;

  const doc = this[_setup.Config].document;
  const target = (_doc$activeElement = doc.activeElement) != null ? _doc$activeElement :
  /* istanbul ignore next */
  doc.body;
  const clipboardData = (0, _utils.copySelection)(target);

  if (clipboardData.items.length === 0) {
    return;
  }

  _dom.fireEvent.cut(target, {
    clipboardData
  });

  if ((0, _utils.isEditable)(target)) {
    var _prepareInput;

    (_prepareInput = (0, _utils.prepareInput)('', target, 'deleteByCut')) == null ? void 0 : _prepareInput.commit();
  }

  if (this[_setup.Config].writeToClipboard) {
    await (0, _utils.writeDataTransferToClipboard)(doc, clipboardData);
  }

  return clipboardData;
}