"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.paste = paste;

var _dom = require("@testing-library/dom");

var _setup = require("../setup");

var _utils = require("../utils");

async function paste(clipboardData) {
  var _doc$activeElement, _ref;

  const doc = this[_setup.Config].document;
  const target = (_doc$activeElement = doc.activeElement) != null ? _doc$activeElement :
  /* istanbul ignore next */
  doc.body;
  const data = (_ref = typeof clipboardData === 'string' ? getClipboardDataFromString(clipboardData) : clipboardData) != null ? _ref : await (0, _utils.readDataTransferFromClipboard)(doc).catch(() => {
    throw new Error('`userEvent.paste()` without `clipboardData` requires the `ClipboardAPI` to be available.');
  });
  return pasteImpl(target, data);
}

function pasteImpl(target, clipboardData) {
  _dom.fireEvent.paste(target, {
    clipboardData
  });

  if ((0, _utils.isEditable)(target)) {
    const data = clipboardData.getData('text').substr(0, (0, _utils.getSpaceUntilMaxLength)(target));

    if (data) {
      var _prepareInput;

      (_prepareInput = (0, _utils.prepareInput)(data, target, 'insertFromPaste')) == null ? void 0 : _prepareInput.commit();
    }
  }
}

function getClipboardDataFromString(text) {
  const dt = (0, _utils.createDataTransfer)();
  dt.setData('text', text);
  return dt;
}