"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.click = click;
exports.dblClick = dblClick;
exports.tripleClick = tripleClick;

var _utils = require("../utils");

var _setup = require("../setup");

async function click(element) {
  if (!this[_setup.Config].skipPointerEventsCheck && !(0, _utils.hasPointerEvents)(element)) {
    throw new Error('unable to click element as it has or inherits pointer-events set to "none".');
  }

  const pointerIn = [];

  if (!this[_setup.Config].skipHover) {
    pointerIn.push({
      target: element
    });
  }

  pointerIn.push({
    keys: '[MouseLeft]',
    target: element
  });
  return this.pointer(pointerIn);
}

async function dblClick(element) {
  if (!this[_setup.Config].skipPointerEventsCheck && !(0, _utils.hasPointerEvents)(element)) {
    throw new Error('unable to double-click element as it has or inherits pointer-events set to "none".');
  }

  return this.pointer([{
    target: element
  }, '[MouseLeft][MouseLeft]']);
}

async function tripleClick(element) {
  if (!this[_setup.Config].skipPointerEventsCheck && !(0, _utils.hasPointerEvents)(element)) {
    throw new Error('unable to triple-click element as it has or inherits pointer-events set to "none".');
  }

  return this.pointer([{
    target: element
  }, '[MouseLeft][MouseLeft][MouseLeft]']);
}