"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createKeyboardState = createKeyboardState;
exports.keyboard = keyboard;
Object.defineProperty(exports, "releaseAllKeys", {
  enumerable: true,
  get: function () {
    return _keyboardAction.releaseAllKeys;
  }
});

var _setup = require("../setup");

var _keyboardAction = require("./keyboardAction");

var _parseKeyDef = require("./parseKeyDef");

async function keyboard(text) {
  const {
    keyboardMap
  } = this[_setup.Config];
  const actions = (0, _parseKeyDef.parseKeyDef)(keyboardMap, text);
  return (0, _keyboardAction.keyboardAction)(this[_setup.Config], actions);
}

function createKeyboardState() {
  return {
    activeElement: null,
    pressed: [],
    carryChar: '',
    modifiers: {
      alt: false,
      caps: false,
      ctrl: false,
      meta: false,
      shift: false
    }
  };
}