"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createPointerState = createPointerState;
exports.pointer = pointer;

var _setup = require("../setup");

var _parseKeyDef = require("./parseKeyDef");

var _pointerAction = require("./pointerAction");

async function pointer(input) {
  const {
    pointerMap
  } = this[_setup.Config];
  const actions = [];
  (Array.isArray(input) ? input : [input]).forEach(actionInput => {
    if (typeof actionInput === 'string') {
      actions.push(...(0, _parseKeyDef.parseKeyDef)(pointerMap, actionInput));
    } else if ('keys' in actionInput) {
      actions.push(...(0, _parseKeyDef.parseKeyDef)(pointerMap, actionInput.keys).map(i => ({ ...actionInput,
        ...i
      })));
    } else {
      actions.push(actionInput);
    }
  });
  return (0, _pointerAction.pointerAction)(this[_setup.Config], actions).then(() => undefined);
}

function createPointerState(document) {
  return {
    pointerId: 1,
    position: {
      mouse: {
        pointerType: 'mouse',
        pointerId: 1,
        target: document.body,
        coords: {
          clientX: 0,
          clientY: 0,
          offsetX: 0,
          offsetY: 0,
          pageX: 0,
          pageY: 0,
          x: 0,
          y: 0
        }
      }
    },
    pressed: []
  };
}