"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clear = clear;
exports.click = click;
exports.copy = copy;
exports.cut = cut;
exports.dblClick = dblClick;
exports.deselectOptions = deselectOptions;
exports.hover = hover;
exports.keyboard = keyboard;
exports.paste = paste;
exports.pointer = pointer;
exports.selectOptions = selectOptions;
exports.tab = tab;
exports.tripleClick = tripleClick;
exports.type = type;
exports.unhover = unhover;
exports.upload = upload;

var _setup = require("./setup");

var _config = require("./config");

function clear(element) {
  return (0, _setup.setupDirect)().clear(element);
}

function click(element, options = {}) {
  return (0, _setup.setupDirect)(options, element).click(element);
}

function copy(options = {}) {
  return (0, _setup.setupDirect)(options).copy();
}

function cut(options = {}) {
  return (0, _setup.setupDirect)(options).cut();
}

function dblClick(element, options = {}) {
  return (0, _setup.setupDirect)(options).dblClick(element);
}

function deselectOptions(select, values, options = {}) {
  return (0, _setup.setupDirect)(options).deselectOptions(select, values);
}

function hover(element, options = {}) {
  return (0, _setup.setupDirect)(options).hover(element);
}

async function keyboard(text, options = {}) {
  const instance = (0, _setup.setupDirect)(options);
  const promise = instance.keyboard(text);
  return promise.then(() => instance[_config.Config].keyboardState);
}

async function pointer(input, options = {}) {
  const instance = (0, _setup.setupDirect)(options);
  const promise = instance.pointer(input);
  return promise.then(() => instance[_config.Config].pointerState);
}

function paste(clipboardData, options) {
  return (0, _setup.setupDirect)(options).paste(clipboardData);
}

function selectOptions(select, values, options = {}) {
  return (0, _setup.setupDirect)(options).selectOptions(select, values);
}

function tripleClick(element, options = {}) {
  return (0, _setup.setupDirect)(options).tripleClick(element);
}

function type(element, text, options = {}) {
  return (0, _setup.setupDirect)(options, element).type(element, text, options);
}

function unhover(element, options = {}) {
  const instance = (0, _setup.setupDirect)(options);
  instance[_config.Config].pointerState.position.mouse.target = element;
  return instance.unhover(element);
}

function upload(element, fileOrFiles, options = {}) {
  return (0, _setup.setupDirect)(options).upload(element, fileOrFiles);
}

function tab(options = {}) {
  return (0, _setup.setupDirect)().tab(options);
}