import { Options } from '../options';
import type { UserEvent } from './index';
import { Config } from './config';
import * as userEventApi from './api';
/**
 * Start a "session" with userEvent.
 * All APIs returned by this function share an input device state and a default configuration.
 */
export declare function setupMain(options?: Options): {
    setup: typeof setupSub;
    [Config]: Config;
    click: typeof userEventApi.click;
    dblClick: typeof userEventApi.dblClick;
    tripleClick: typeof userEventApi.tripleClick;
    hover: typeof userEventApi.hover;
    unhover: typeof userEventApi.unhover;
    tab: typeof userEventApi.tab;
    keyboard: typeof userEventApi.keyboard;
    copy: typeof userEventApi.copy;
    cut: typeof userEventApi.cut;
    paste: typeof userEventApi.paste;
    pointer: typeof userEventApi.pointer;
    clear: typeof userEventApi.clear;
    deselectOptions: typeof userEventApi.deselectOptions;
    selectOptions: typeof userEventApi.selectOptions;
    type: typeof userEventApi.type;
    upload: typeof userEventApi.upload;
};
/**
 * Setup in direct call per `userEvent.anyApi()`
 */
export declare function setupDirect(options?: Partial<Config>, node?: Node): {
    setup: typeof setupSub;
    [Config]: Config;
    click: typeof userEventApi.click;
    dblClick: typeof userEventApi.dblClick;
    tripleClick: typeof userEventApi.tripleClick;
    hover: typeof userEventApi.hover;
    unhover: typeof userEventApi.unhover;
    tab: typeof userEventApi.tab;
    keyboard: typeof userEventApi.keyboard;
    copy: typeof userEventApi.copy;
    cut: typeof userEventApi.cut;
    paste: typeof userEventApi.paste;
    pointer: typeof userEventApi.pointer;
    clear: typeof userEventApi.clear;
    deselectOptions: typeof userEventApi.deselectOptions;
    selectOptions: typeof userEventApi.selectOptions;
    type: typeof userEventApi.type;
    upload: typeof userEventApi.upload;
};
/**
 * Create a set of callbacks with different default settings but the same state.
 */
export declare function setupSub(this: UserEvent, options: Options): {
    setup: typeof setupSub;
    [Config]: Config;
    click: typeof userEventApi.click;
    dblClick: typeof userEventApi.dblClick;
    tripleClick: typeof userEventApi.tripleClick;
    hover: typeof userEventApi.hover;
    unhover: typeof userEventApi.unhover;
    tab: typeof userEventApi.tab;
    keyboard: typeof userEventApi.keyboard;
    copy: typeof userEventApi.copy;
    cut: typeof userEventApi.cut;
    paste: typeof userEventApi.paste;
    pointer: typeof userEventApi.pointer;
    clear: typeof userEventApi.clear;
    deselectOptions: typeof userEventApi.deselectOptions;
    selectOptions: typeof userEventApi.selectOptions;
    type: typeof userEventApi.type;
    upload: typeof userEventApi.upload;
};
