"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.type = type;

var _utils = require("../utils");

var _keyboard = require("../keyboard");

var _config = require("../setup/config");

async function type(element, text, {
  skipClick = this[_config.Config].skipClick,
  skipAutoClose = this[_config.Config].skipAutoClose,
  initialSelectionStart,
  initialSelectionEnd
} = {}) {
  // TODO: properly type guard
  // we use this workaround for now to prevent changing behavior
  if (element.disabled) return;

  if (!skipClick) {
    await this.click(element);
  }

  if (initialSelectionStart !== undefined) {
    (0, _utils.setSelectionRange)(element, initialSelectionStart, initialSelectionEnd != null ? initialSelectionEnd : initialSelectionStart);
  }

  await this.keyboard(text);

  if (!skipAutoClose) {
    await (0, _keyboard.releaseAllKeys)(this[_config.Config]);
  }
}