"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.copySelection = copySelection;

var _document = require("../../document");

var _DataTransfer = require("../dataTransfer/DataTransfer");

var _selection = require("./selection");

function copySelection(target) {
  const data = (0, _selection.hasOwnSelection)(target) ? {
    'text/plain': readSelectedValueFromInput(target)
  } : // TODO: We could implement text/html copying of DOM nodes here
  {
    'text/plain': String(target.ownerDocument.getSelection())
  };
  const dt = (0, _DataTransfer.createDataTransfer)();

  for (const type in data) {
    if (data[type]) {
      dt.setData(type, data[type]);
    }
  }

  return dt;
}

function readSelectedValueFromInput(target) {
  const sel = (0, _document.getUISelection)(target);
  const val = (0, _document.getUIValue)(target);
  return val.substring(sel.startOffset, sel.endOffset);
}